clear all;
load ca-GrQc.mat;
%load ca-HepPh.mat;
%load ca-HepTh.mat 
%============= parameters here
rate = 0.5;
beta = 0.0001;
maxk=5;
%rho=1e-5;
rho = 1e-3;
alpha = 1e-3;
k=50;
maxiter = 40;
rand('seed',0);
fprintf('The rate is %f,the beta is %f,maxkatz is %d\n', rate, beta, maxk);
fprintf('rho is %f, alpha is %f, rank is %d, maxiter is %d\n', rho, alpha, k, maxiter);
%============= split the dataset
A = A-diag(diag(A));
n = size(A,2);
[i j v] = find(triu(A));
g = rand(size(i));
train = sparse(i(g>=rate),j(g>=rate),v(g>=rate),n,n);
test = sparse(i(g<rate),j(g<rate),v(g<rate),n,n);
tn = nnz(test);
train = train + train';
%kk = [0.01:0.05:2];
kk = [0.3:0.1:3];
percent = ceil(kk*tn);
%================ Bias-MF
%display('begin Multiscale and multiscale-katz');
tic
[W,H] = matFact_mex(train,k,maxiter,rho,alpha);
display('end CCD');
toc
Ak = sparse(W'*H);
Ak = Ak-1e10*train;
[CCFPR, CCFNR,CCAcc] = evalscore(Ak,test,percent);

%================ CN
tic
display('begin computing CN');
Ak = train*train;
display('end computing CN');
toc
Ak = Ak-1e10*train;
[CNFPR, CNFNR, CNAcc] = evalscore(Ak,test,percent);

%================ SVD

tic;
display('begin computing SVD');
[U,DD] = eigs(train,k,'LM');
%DD = compKatzCore(DD,beta);
Ak = sparse(U*DD*U');
display('end computing SVD');
toc
Ak = Ak-1e10*train;
[svdFPR, svdFNR, svdAcc] = evalscore(Ak,test,percent);

%%% plotting 
figure(1);
plot(percent, CCAcc, percent, CNAcc, percent, svdAcc, 'LineWidth', 2);
legend('BiasMC', 'Common Neighbor', 'svd');
set(gca,'Fontsize',20,'FontWeight','bold');
print -dpng acc.png

figure(2);
plot(CCFPR, CCFNR, CNFPR, CNFNR, svdFPR, svdFNR)
legend('BiasMC', 'Common Neighbor', 'svd');
set(gca,'Fontsize',20,'FontWeight','bold');
print -dpng roc.png
